var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var plt;
(function (plt) {
    var BasePlt = /** @class */ (function () {
        function BasePlt(pid) {
            this._lastPayTime = 0;
            this.data = {};
            this._pid = pid;
        }
        /**初始化数据 */
        BasePlt.prototype.flushData = function (data) {
            var s = this;
            var vo = this.data;
            vo.uname = data.uname;
            vo.roleId = data.playerid + '';
            vo.roleName = data.name;
            vo.roleLevel = data.level;
            vo.vip = data.vipLv;
            vo.serverId = js_gameVars.zoneid;
            vo.serverName = '天堂岛' + js_gameVars.zoneid + '区';
            vo.opSid = s.getOpId();
            console.log("区服 id  = " + vo.opSid);
            vo.roleCreateTime = Math.floor(data.createTime / 1000);
        };
        Object.defineProperty(BasePlt.prototype, "pid", {
            /**
             * 每个平台文件的id
             */
            get: function () {
                return this._pid;
            },
            enumerable: true,
            configurable: true
        });
        // /**是否开启分享功能 */
        // public getHasShare() {
        // 	let s = this;
        // 	return s.needShare;
        // }
        /**支付 */
        BasePlt.prototype.pay = function (info, type, param) {
            var s = this;
            if (egret.getTimer() - s._lastPayTime < 1000) {
                // byh.ui.showMsg('操作过于频繁，请稍后再试！');
                return;
            }
            s._lastPayTime = egret.getTimer();
        };
        /**进入游戏*/
        BasePlt.prototype.enterGame = function (isNewUser) {
            if (isNewUser === void 0) { isNewUser = false; }
            if (isNewUser)
                this.onCreateRole();
        };
        BasePlt.prototype.onCreateRole = function () {
        };
        BasePlt.prototype.onEnterGame = function (isNewUser) {
            if (isNewUser === void 0) { isNewUser = false; }
        };
        /**升级调用*/
        BasePlt.prototype.roleLvlUp = function () {
        };
        BasePlt.prototype.getDTSLogData = function () {
            var uaInfo = byh.UserAgent.getUA() || {};
            var version = (js_gameVars.version || "").replace('_', '.');
            return {
                op_id: js_gameVars.op_id || "",
                device: "",
                channel_id: js_gameVars.channel || "",
                game_ver: version,
                bundle_id: "",
                device_type: uaInfo.device_type || "",
                device_os: uaInfo.device_os || "",
                factory: uaInfo.factory || "",
                model: uaInfo.model || ""
            };
        };
        /**平台打开网页 */
        BasePlt.prototype.toOpenUrl = function (url) {
            console.log("平台打开网页：" + url);
        };
        /**
         * 是否开启登出功能
         */
        BasePlt.prototype.getHasLoginOut = function () {
            return false;
        };
        /**
         * 是否开启论坛功能
         */
        // getHasForum(): boolean {
        // 	return false;
        // }
        // /**
        //  * 是否开启用户中心功能
        //  */
        // getHasUserCenter(): boolean {
        // 	return false;
        // }
        /**
         * 是否开启客服功能
         */
        // getHasCustomServer(): boolean {
        // 	return false;
        // }
        /**是否展示隐私政策 */
        BasePlt.prototype.getHasUserPrivacy = function () {
            return false;
        };
        /**获取渠道opId */
        BasePlt.prototype.getOpId = function () {
            return "";
        };
        return BasePlt;
    }());
    plt.BasePlt = BasePlt;
})(plt || (plt = {}));
/// <reference path="../base/BasePlt.ts" />
var plt;
(function (plt) {
    var YzWdPlt = /** @class */ (function (_super_1) {
        __extends(YzWdPlt, _super_1);
        /**设备信息 */
        // private _collectionData:CollectionDataInfo;
        // private _deviceInfo:DeviceInfo;
        // private _userInfo:UserInfo;
        function YzWdPlt() {
            var _this = _super_1.call(this, 1 /* YZWD */) || this;
            var s = _this;
            // s.platformId = PltId.yzwd;//暂定
            s.sdk = window['wdsdk'];
            return _this;
            // s.userPrivacy = true;
            // s.userCenter = true;
            // s.userForum = true;
            // s.userKefu = true;
            // s.userZhuxiao = true;
            // s.needShare = true;
            // if (s.getOpId() == 2891)//凯格包不显示分享
            // {
            // 	s.needShare = false;
            // }
        }
        /**游族微端支付 */
        YzWdPlt.prototype.pay = function (info, type, param) {
            var s = this;
            if (s.getOpId() == 2891) //凯格包暂停充值
             {
                s.toAlert("充值未开放");
                return;
            }
            var id = info.id;
            if (type && type != 0 /* Common */) {
                id = info.id + ":" + type + ":" + param;
            }
            var extraVo = { operateId: js_gameVars.platform, type: type, param: param }; //充值的扩展参数
            var vo = {
                price: Math.round(info.price / 100),
                productId: id,
                productName: info.name,
                productDesc: "说明",
                pointRate: 100,
                pointName: '钻石',
                orderTitle: '购买钻石',
                extra: JSON.stringify(extraVo)
            };
            // let s = this;
            // let js_gameVars = window['js_gameVars'];
            if (js_gameVars && js_gameVars.directPay) {
                var phpurl = js_gameVars.phpurl;
                var request = new egret.HttpRequest();
                var server_id = 'server_id=' + s.data.serverId;
                var product_id = '&product_id=' + vo.productId;
                var game_role_id = '&game_role_id=' + s.data.roleId;
                var url = phpurl + "yzwd/payTest.php?";
                url = url + server_id + product_id + game_role_id;
                request.open(url, egret.HttpMethod.GET);
                request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                request.send();
                console.log('directPay', url);
                return;
            }
            // if (s.sdk && s.sdk.onAdPay) s.sdk.onAdPay(s.adDataJsonStr(), JSON.stringify(vo));//先调用此方法初始化要发送的参数，在调用toPay， 否则会导致有问题。已废弃，添加onPaySuccess
            if (s.sdk && s.sdk.toPay)
                s.sdk.toPay(JSON.stringify(vo));
        };
        /**分享 */
        YzWdPlt.prototype.toShare = function (body) {
            var s = this;
            console.log('toShare');
            if (s.sdk && s.sdk.toShare)
                s.sdk.toShare(body.title, body.content, body.titleUrl, body.images, body.url, body.platform);
        };
        /**========================================登陆罗盘数据上报===================================*/
        /**进入登陆页面<当游戏打开登录页面时调用。首次打开登录页面，及注销回到登录页面都要调用此接口>*/
        YzWdPlt.prototype.enterLoinView = function () {
            var s = this;
            console.log('onEnterLogin');
            if (s.sdk && s.sdk.onEnterLogin)
                s.sdk.onEnterLogin();
        };
        /**进入游戏*/
        YzWdPlt.prototype.enterGame = function (isNewUser) {
            if (isNewUser === void 0) { isNewUser = false; }
            var s = this;
            console.log('onEnterGame');
            if (s.sdk && s.sdk.onEnterGame)
                s.sdk.onEnterGame(s.dataJsonStr());
            if (isNewUser || (window["byh"] && window["byh"]["userModel"] && window["byh"]["userModel"]["isFirstLogin"])) {
                s.onCreateRole();
            }
            s.onAdLogin();
            s.onEnterGameHome();
        };
        /**创角*/
        YzWdPlt.prototype.onCreateRole = function () {
            var s = this;
            console.log('onCreateRole');
            if (s.sdk && s.sdk.onCreateRole)
                s.sdk.onCreateRole(s.dataJsonStr());
            s.onAdCreateRole();
        };
        /**升级调用*/
        YzWdPlt.prototype.roleLvlUp = function () {
            var s = this;
            console.log('onLevelUp');
            if (s.sdk && s.sdk.onLevelUp)
                s.sdk.onLevelUp(s.dataJsonStr());
            s.onAdLevelUp();
        };
        /**进入游戏主界面<游戏打开游戏主城，即首页时调用>*/
        YzWdPlt.prototype.onEnterGameHome = function () {
            var s = this;
            console.log('onEnterGameHome');
            if (s.sdk && s.sdk.onEnterGameHome)
                s.sdk.onEnterGameHome();
        };
        /**登陆广告上报 */
        YzWdPlt.prototype.onAdLogin = function () {
            var s = this;
            console.log('onAdLogin');
            if (s.sdk && s.sdk.onAdLogin)
                s.sdk.onAdLogin(s.adDataJsonStr());
        };
        /**创角广告上报 */
        YzWdPlt.prototype.onAdCreateRole = function () {
            var s = this;
            console.log('onAdCreateRole');
            if (s.sdk && s.sdk.onAdRegister)
                s.sdk.onAdRegister(s.adDataJsonStr());
            if (s.sdk && s.sdk.onAdCreateRole)
                s.sdk.onAdCreateRole(s.adDataJsonStr());
        };
        /**升级广告上报 */
        YzWdPlt.prototype.onAdLevelUp = function () {
            var s = this;
            console.log('onAdLevelUp');
            if (s.sdk && s.sdk.onAdLevelUp)
                s.sdk.onAdLevelUp(s.adDataJsonStr());
        };
        /**玩家支付成功 */
        YzWdPlt.prototype.onPaySuccess = function (orderId, amount, productId, productName) {
            var s = this;
            console.log('onAdLevelUp');
            var data = s.getAdData();
            data.orderId = orderId;
            data.amount = amount;
            data.productId = productId;
            data.productName = productName;
            data.way = s.getOpId();
            // data.currency = currency;//RMB
            data.type = "";
            data.discount = "";
            if (s.sdk && s.sdk.onPaySuccess)
                s.sdk.onPaySuccess(JSON.stringify(data));
        };
        //=========================用户隐私政策=====================//
        /**打开用户协议*/
        YzWdPlt.prototype.toOpenUserService = function () {
            var s = this;
            if (s.sdk && s.sdk.toOpenUserService)
                s.sdk.toOpenUserService();
        };
        /**打开用户隐私*/
        YzWdPlt.prototype.toOpenPrivacy = function () {
            var s = this;
            if (s.sdk && s.sdk.toOpenPrivacy)
                s.sdk.toOpenPrivacy();
        };
        /**打开论坛*/
        YzWdPlt.prototype.toOpenForum = function () {
            var s = this;
            if (s.sdk && s.sdk.toForum)
                s.sdk.toForum();
        };
        /**打开用户中心*/
        YzWdPlt.prototype.toOpenUserCente = function () {
            var s = this;
            if (s.sdk && s.sdk.toUserCenter)
                s.sdk.toUserCenter();
        };
        /**打开客服中心 */
        YzWdPlt.prototype.toOpenCustomServer = function () {
            var s = this;
            if (s.sdk && s.sdk.toCustomServer)
                s.sdk.toCustomServer();
        };
        /**退出 */
        YzWdPlt.prototype.toOpenExit = function () {
            var s = this;
            if (s.sdk && s.sdk.toExit)
                s.sdk.toExit();
        };
        /**是否展示隐私政策 */
        YzWdPlt.prototype.getHasUserPrivacy = function () {
            return false;
        };
        /**注销 */
        YzWdPlt.prototype.toLoginOut = function () {
            var s = this;
            if (s.sdk && s.sdk.toLoginOut)
                s.sdk.toLoginOut();
        };
        /**打开防沉迷面板
         *
         * "is_adult" type="int" des="0:未成年 2：未实名"
            is_fcm  type="int" des="是否触发防沉迷 0:未触发 1：触发"
            "fcm_status" type="int" des="防沉迷状态"
            remaining_time" type="int" des="剩余时间(分钟)"
        */
        YzWdPlt.prototype.toOpenFCM = function (is_adult, is_fcm, fcm_status, remaining_time) {
            var s = this;
            if (!s.sdk)
                return;
            var alertStr;
            if (is_adult == 0) //未成年
             {
                if (fcm_status == 1) {
                    alertStr = "由于您未成年，已被纳入防沉迷系统，每日晚22：00至次日8:00 不允许游戏";
                }
                else if (fcm_status == 2) {
                    alertStr = "由于您未成年，已被纳入防沉迷系统，法定节假日已达到最大游戏时长3小时";
                }
                else if (fcm_status == 3) {
                    alertStr = "由于您未成年，已被纳入防沉迷系统，非法定节假日已达到最大游戏时长1.5小时";
                }
            }
            else if (is_adult == 2) //未实名
             {
                if (fcm_status == 1) {
                    alertStr = "由于您未实名认证，已被纳入防沉迷系统，每日晚22：00至次日8:00 不允许游戏。请前往官网进行实名，若已实名，请稍候重试";
                }
                else if (fcm_status == 2) {
                    alertStr = "由于您未实名认证，已被纳入防沉迷系统，法定节假日已达到最大游戏时长3小时。请前往官网进行实名，若已实名，请稍候重试";
                }
                else if (fcm_status == 3) {
                    alertStr = "由于您未实名认证，已被纳入防沉迷系统，非法定节假日已达到最大游戏时长1.5小时。请前往官网进行实名，若已实名，请稍候重试";
                }
            }
            if (!alertStr && remaining_time <= 15) {
                if (is_adult == 0)
                    alertStr = "由于您未成年，已被纳入防沉迷系统，今日可游戏时间剩余15分钟";
                // else if(is_adult == 2)
                // 	alertStr = "由于您未实名认证，已被纳入防沉迷系统，今日可游戏时间剩余15分钟";
            }
            console.log(alertStr);
            if (alertStr && s.sdk.toAlert)
                s.sdk.toAlert(alertStr);
            if (s.sdk.toOpenFCM && is_fcm == 1) {
                console.log("调用打开防沉迷:  toOpenFCM");
                s.sdk.toOpenFCM();
            }
        };
        /**
         * 弹窗提示
         * @param alertMsg
         */
        YzWdPlt.prototype.toAlert = function (alertMsg) {
            var s = this;
            if (s.sdk && s.sdk.toAlert)
                s.sdk.toAlert(alertMsg);
        };
        /**
         * 弹出登录
         */
        YzWdPlt.prototype.toLogin = function () {
            var s = this;
            if (s.sdk && s.sdk.toLogin)
                s.sdk.toLogin();
        };
        YzWdPlt.prototype.dataJsonStr = function () {
            return JSON.stringify(this.data);
        };
        YzWdPlt.prototype.adDataJsonStr = function () {
            var s = this;
            // let js_gameVars = window['js_gameVars'];
            // let vo = {
            // 	"osdk_user_id": js_gameVars.uname,
            // 	serverId: s.data.serverId,
            // 	level: s.data.roleLevel,
            // 	roleId: s.data.roleId,
            // 	roleName: s.data.roleName,
            // 	roleType: -1,
            // 	roleCareer: -1,
            // };
            return JSON.stringify(s.getAdData());
        };
        YzWdPlt.prototype.getAdData = function () {
            var s = this;
            // let js_gameVars = window['js_gameVars'];
            var vo = {
                "osdk_user_id": js_gameVars.uname,
                serverId: s.data.serverId,
                level: s.data.roleLevel,
                roleId: s.data.roleId,
                roleName: s.data.roleName,
                roleType: -1,
                roleCareer: -1,
            };
            return vo;
        };
        /**
         * 获取DTS日志上报相关的数据
         */
        YzWdPlt.prototype.getDTSLogData = function () {
            var s = this;
            if (!s.sdk) //没有使用微端登录的时候opid传为0
             {
                return { op_id: "0", device: "", channel_id: "", game_ver: "", bundle_id: "", device_type: "", device_os: "", factory: "", model: "" };
            }
            var info = {};
            var deviceInfo;
            var userInfo;
            var collectionData;
            if (s.sdk && s.sdk.getDeviceInfo)
                deviceInfo = JSON.parse(s.sdk.getDeviceInfo());
            if (js_gameVars)
                userInfo = js_gameVars.userInfo;
            if (s.sdk && s.sdk.getCollectionData)
                collectionData = JSON.parse(s.sdk.getCollectionData());
            if (deviceInfo) {
                info.device = deviceInfo.device_id || "";
                info.device_os = deviceInfo.os || "";
                info.factory = deviceInfo.factory || "";
                info.model = deviceInfo.model || "";
            }
            else {
                info.device = "";
                info.device_os = "";
                info.factory = "";
                info.model = "";
            }
            if (collectionData) {
                info.bundle_id = collectionData.bundle_id || "";
                info.device_type = collectionData.device_type || "";
            }
            else {
                info.bundle_id = "";
                info.device_type = "";
            }
            if (userInfo) {
                info.channel_id = userInfo.channel_id || "";
            }
            else {
                info.channel_id = "";
            }
            if (s.sdk && s.sdk.getOpId) {
                info.op_id = s.sdk.getOpId() + "";
            }
            else {
                info.op_id = "";
            }
            if (s.sdk && s.sdk.getVersionCode) {
                info.game_ver = s.sdk.getVersionCode() + "";
            }
            else {
                info.game_ver = "";
            }
            return info;
        };
        /**
         * 是否开启登出功能
         */
        YzWdPlt.prototype.getHasLoginOut = function () {
            var s = this;
            if (s.sdk && s.sdk.getHasLoginOut)
                return s.sdk.getHasLoginOut();
            return false;
        };
        /**
         * 是否开启论坛功能
         */
        YzWdPlt.prototype.getHasForum = function () {
            var s = this;
            if (s.sdk && s.sdk.getHasForum)
                return s.sdk.getHasForum();
            return false;
        };
        /**
         * 是否开启用户中心功能
         */
        YzWdPlt.prototype.getHasUserCenter = function () {
            var s = this;
            if (s.sdk && s.sdk.getHasUserCenter)
                return s.sdk.getHasUserCenter();
            return false;
        };
        /**
         * 是否开启客服功能
         */
        YzWdPlt.prototype.getHasCustomServer = function () {
            var s = this;
            if (s.sdk && s.sdk.getHasCustomServer)
                return s.sdk.getHasCustomServer();
            return false;
        };
        /**获取渠道opId */
        YzWdPlt.prototype.getOpId = function () {
            var s = this;
            if (s.sdk && s.sdk.getOpId)
                return s.sdk.getOpId();
            return "";
        };
        return YzWdPlt;
    }(plt.BasePlt));
    plt.YzWdPlt = YzWdPlt;
})(plt || (plt = {}));
/***Android 调用的回调方法 */
window['androidCallJsMethod'] = function (type, params) {
    console.log("收到回调： " + type + "   值： " + params);
    if (type == "getToken") //收到token
     {
        // byh.observer.post(plt.PltEvent.GET_TOKEN, params);
        plt.platform.post(1 /* GET_TOKEN */, params);
    }
    else if (type == "getLoginOut") //注销
     {
        plt.platform.post(2 /* LOGIN_OUT */, params);
    }
    return type;
};
window['plt.PlatForm'] = new plt.YzWdPlt();
var wdsdk;
(function (wdsdk) {
    ///////////////////////////////////////////////////////////////////
    /////////玩家操作  toXXXX():any
    //////////////////////////////////////////////////////////////////
})(wdsdk || (wdsdk = {}));
var plt;
(function (plt) {
    var PltMethodCall = /** @class */ (function () {
        function PltMethodCall() {
        }
        PltMethodCall.prototype.call = function (methodName) {
            var params = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                params[_i - 1] = arguments[_i];
            }
            var s = this;
            if (!plt.platform) {
                console.log("当前没有平台");
                return;
            }
            if (s.platform[methodName] == undefined) { //
                console.log("当前平台没有  " + methodName + " 方法");
                return;
            }
            if (typeof s.platform[methodName] == "function") {
                var fun = s.platform[methodName];
                return fun.apply(s.platform, params);
            }
            return s.platform[methodName];
        };
        Object.defineProperty(PltMethodCall.prototype, "platform", {
            get: function () {
                var s = this;
                if (!s._platform) {
                    s._platform = window['plt.PlatForm'];
                }
                return s._platform;
            },
            enumerable: true,
            configurable: true
        });
        // private pay(info: RechargeCfg, type?: number, param?: string | number) {
        // 	let s = this;
        // 	if (!s.plt) {
        // 		// byh.ui.showMsg('未接入渠道SDK！');
        // 		return;
        // 	}
        // 	if (egret.getTimer() - s._lastPayTime < 1000) {
        // 		// byh.ui.showMsg('操作过于频繁，请稍后再试！');
        // 		return;
        // 	}
        // 	if (s.plt) s.plt.pay(info, type, param);
        // 	s._lastPayTime = egret.getTimer();
        // }
        PltMethodCall.prototype.post = function (event, data) {
            if (data === void 0) { data = null; }
            byh.observer.post(PltMethodCall.EventPreStr + event, data);
        };
        PltMethodCall.prototype.on = function (event, handler, target) {
            byh.observer.on(PltMethodCall.EventPreStr + event, handler, target);
        };
        PltMethodCall.prototype.off = function (event, handler, target) {
            byh.observer.off(PltMethodCall.EventPreStr + event, handler, target);
        };
        PltMethodCall.EventPreStr = "plt_";
        return PltMethodCall;
    }());
    plt.PltMethodCall = PltMethodCall;
    plt.platform = new PltMethodCall();
})(plt || (plt = {}));
